#include <bits/stdc++.h>
using namespace std;
	long long int a[1000000];
long long int nzd(long long int a, long long int b)
{
    if (b == 0)
        return a;
    return nzd(b, a % b); 
     
}
int main()
{
	 ios::sync_with_stdio(0); 
	  cin.tie(0); 
	  cout.tie(0);
	  int t;
	  cin>>t;
	  int g[6];
	   long long int s;
	  for(int i=1; i<=t; i++)
{
	long long int n,m;

	cin>>n>>m;

	for(int j=1; j<=n; j++)
	{
		cin>>a[j];
	
	}
	a[0]=0;
	sort(a,a+n);
	for(int l=2; l<=n; l++)
	{
		if(l==2)
		{
		s=abs(a[2]-a[1]);
	
	}
		else 
		{
			s=nzd(s,abs(a[l]-a[l-1]));
		}
	}

	long long int u=0;

	for(int k=1; k<=m; k++)
	{
		long long int b;
		cin>>b;
		
		if(s>1)
		{
		if(abs(a[1]-b)%s==0)
		{
			u++;
		
		}
		
		}
	
		
	}

	if(u==0 && s!=1) cout<<"1"<<"\n";
	else cout<<"0"<<"\n";
}

}